package com.iconplus.smartproc.service.rksdaftarisi;

import com.iconplus.smartproc.helper.service.BaseService;
import com.iconplus.smartproc.model.entity.RksDaftarIsi;
import com.iconplus.smartproc.model.request.RksDaftarIsiRequest;
import com.iconplus.smartproc.model.response.ListRksIsiResponse;
import com.iconplus.smartproc.model.response.RksDaftarIsiResponse;
import com.iconplus.smartproc.repository.RksDaftarIsiRepository;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

@Service
public class GetListRksParentService implements BaseService<RksDaftarIsiRequest, ListRksIsiResponse> {

    private final RksDaftarIsiRepository rksDaftarIsiRepository;
    public GetListRksParentService(RksDaftarIsiRepository rksDaftarIsiRepository) {
        this.rksDaftarIsiRepository = rksDaftarIsiRepository;
    }

    @Override
    public ListRksIsiResponse execute(RksDaftarIsiRequest input) {

        List<RksDaftarIsiResponse> rksDaftarIsiResponseList = new ArrayList<>();
        var rksIsiList = rksDaftarIsiRepository.findByParentRksDaftarIsi(input.getRksDaftarId());

        for (RksDaftarIsi rksDaftarIsi : rksIsiList) {
            RksDaftarIsiResponse rksDaftarIsiResponse = RksDaftarIsiResponse.builder()
                    .id(rksDaftarIsi.getId())
                    .title(rksDaftarIsi.getTitle())
                    .build();
            rksDaftarIsiResponseList.add(rksDaftarIsiResponse);
        }

        return ListRksIsiResponse.builder()
                .data(rksDaftarIsiResponseList)
                .build();
    }
}
